const urlSVG = 'http://www.w3.org/2000/svg';
const createSVGElement = (element) =>
  document.createElementNS(urlSVG, element);


const getRandomInt = (min, max) => {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min) + min); //The maximum is exclusive and the minimum is inclusive
}

const getRandomArbitrary = (min, max) => {
  return Math.random() * (max - min) + min;
}
const myDefs = createSVGElement('defs');

// const myGradient = createSVGElement('linearGradient');
// myGradient.setAttribute('id', 'myGradient');

// let stop = createSVGElement('stop');
// stop.setAttribute('offset', '5%');
// stop.setAttribute('stop-color', 'blue');
// myGradient.appendChild(stop);

// stop = createSVGElement('stop');
// stop.setAttribute('offset', '95%');
// stop.setAttribute('stop-color', 'red');
// myGradient.appendChild(stop);

const radialGradient = createSVGElement('radialGradient');
			radialGradient.setAttribute('id',"sunGradient");
			radialGradient.setAttribute('cx',"50%");
			radialGradient.setAttribute('cy',"50%");
			radialGradient.setAttribute('r',"75%");
			radialGradient.setAttribute('fx',"50%");
			radialGradient.setAttribute('fy',"50%");
			stop = createSVGElement('stop');
			stop.setAttribute('offset', '0%');
			stop.setAttribute('style', "stop-color:rgb(255,255,0);");
			stop.setAttribute('stop-opacity',"1");
			radialGradient.appendChild(stop);
			stop = createSVGElement('stop');
			stop.setAttribute('offset', '100%');
			stop.setAttribute('style', "stop-color:rgb(255,125,0);");
			stop.setAttribute('stop-opacity',"1");
      radialGradient.appendChild(stop);




const skyGradient = createSVGElement('linearGradient');
      skyGradient.setAttribute('id', 'skyGradient');
      skyGradient.setAttribute('x1', '0%');
      skyGradient.setAttribute('y1', '0%');
      skyGradient.setAttribute('x2', '0%');
      skyGradient.setAttribute('y2', '100%');

      stop = createSVGElement('stop');
      stop.setAttribute('offset', '100%');
      stop.setAttribute('stop-color', 'rgb(10,10,220)');
      stop.setAttribute('id', 'zenith');

let animate = createSVGElement('animate');
    animate.setAttribute('dur', '24s');
    animate.setAttribute(
      'values',
      'rgba(0,0,12,0);rgba(2,1,17,0);rgba(2,1,17,0);rgba(2,1,17,0);rgba(32,32,44,0.5);rgba(64,64,92,.8);rgb(74,73,105);rgb(117,122,191);rgb(130,173,219);rgb(138,197,248);rgb(143,200,255);rgb(150, 225, 255);rgb(144,223,255);rgb(87,193,245);rgb(45,145,224);rgb(36,115,220);rgb(30,82,212);rgb(30,82,208);rgb(21,66,200);rgba(22,60,182,0.8);rgba(7,27,138,.5);rgba(1,10,116,.3);rgba(9,4,11,0);rgba(0,0,12,0);'
    );
    animate.setAttribute('repeatCount', 'indefinite');
stop.appendChild(animate);

animate = createSVGElement('animate');
animate.setAttribute('attributeName', 'offset');
animate.setAttribute('dur', '24s');
animate.setAttribute(
  'values',
  '0;.85;.6;.1;0;0;0;0;0;.01;0;0;0;0;0;0;0;0;0;0;.3,.5,.8,0'
);
animate.setAttribute('repeatCount', 'indefinite');
stop.appendChild(animate);

skyGradient.appendChild(stop);

stop = createSVGElement('stop');
stop.setAttribute('offset', '100%');
stop.setAttribute('stop-color', 'rgb(10,10,220)');
stop.setAttribute('id', 'horizon');

animate = createSVGElement('animate');
animate.setAttribute('attributeName', 'stop-color');
animate.setAttribute('dur', '24s');
animate.setAttribute(
  'values',
  'rgba(0,0,12,0);rgba(25,22,33,.3);rgba(32,32,44,.8);rgb(58,58,82);rgb(81,81,117);rgb(138,118,171);rgb(205,130,160);rgb(234,176,209);rgb(235,178,177);rgb(177,181,234);rgb(148,223,255);rgb(103,209,255);rgb(91,121,250);rgb(100,166,113);rgb(100,206,93);rgb(98,99,57);rgb(47,17,7);rgb(36,14,3);rgb(56,163,209);rgb(36,111,168);rgb(30,82,142);rgb(47,17,7);rgba(75,29,6,.4);rgba(21,8,0,0);rgba(0,0,12,0)'
);
animate.setAttribute('repeatCount', 'indefinite');
animate.setAttribute('dur', '24s');
stop.appendChild(animate);
skyGradient.appendChild(stop);

const bird = () => {
  const bird_group = createSVGElement('g');
  bird_group.setAttribute('id', 'bird');

  const bird_body = createSVGElement('g');
  bird_body.setAttribute('id', 'body');

  const bird_body_path1 = createSVGElement('path');
  bird_body_path1.setAttribute(
    'd',
    'M48.42,78.11c0-17.45,14.14-31.58,31.59-31.58s31.59,14.14,31.59,31.58c0,17.44-14.14,31.59-31.59,31.59 S48.42,95.56,48.42,78.11'
  );
  bird_body.appendChild(bird_body_path1);

  const bird_body_path2 = createSVGElement('path');
  bird_body_path2.setAttribute(
    'd',
    'M109.19,69.88c0,0-8.5-27.33-42.51-18.53c-34.02,8.81-20.65,91.11,45.25,84.73 c40.39-3.65,48.59-24.6,48.59-24.6S124.68,106.02,109.19,69.88'
  );
  bird_body.appendChild(bird_body_path2);

  const bird_wing = createSVGElement('path');
  bird_wing.setAttribute(
    'd',
    'M105.78,75.09c4.56,0,8.84,1.13,12.62,3.11c0,0,0.01-0.01,0.01-0.01l36.23,12.38c0,0-13.78,30.81-41.96,38.09 c-1.51,0.39-2.82,0.59-3.99,0.62c-0.96,0.1-1.92,0.16-2.9,0.16c-15.01,0-27.17-12.17-27.17-27.17 C78.61,87.26,90.78,75.09,105.78,75.09'
  );
  bird_wing.setAttribute('id', 'wing');
  bird_body.appendChild(bird_wing);
  bird_group.appendChild(bird_body);

  const bird_head = createSVGElement('g');
  bird_head.setAttribute('id', 'head');

  const bird_beak = createSVGElement('path');
  bird_beak.setAttribute(
    'd',
    'M50.43,68.52c0,0-8.81,2.58-10.93,4.86l9.12,9.87C48.61,83.24,48.76,74.28,50.43,68.52'
  );
  bird_beak.setAttribute('id', 'beak');
  bird_head.appendChild(bird_beak);

  const bird_eye_ball = createSVGElement('path');
  bird_eye_ball.setAttribute(
    'd',
    'M60.53,71.68c0-6.33,5.13-11.46,11.46-11.46c6.33,0,11.46,5.13,11.46,11.46c0,6.33-5.13,11.46-11.46,11.46 C65.66,83.14,60.53,78.01,60.53,71.68'
  );
  bird_eye_ball.setAttribute('class', 'eye-ball');
  bird_head.appendChild(bird_eye_ball);

  const bird_pupil = createSVGElement('path');
  bird_pupil.setAttribute(
    'd',
    'M64.45,71.68c0-4.16,3.38-7.53,7.54-7.53c4.16,0,7.53,3.37,7.53,7.53c0,4.16-3.37,7.53-7.53,7.53 C67.82,79.22,64.45,75.84,64.45,71.68'
  );
  bird_pupil.setAttribute('id', 'pupil');
  bird_head.appendChild(bird_pupil);

  const bird_eye_ball2 = createSVGElement('path');
  bird_eye_ball2.setAttribute(
    'd',
    'M72.39,74.39c0-2.73,2.22-4.95,4.95-4.95c2.73,0,4.95,2.21,4.95,4.95c0,2.74-2.22,4.95-4.95,4.95 C74.6,79.34,72.39,77.13,72.39,74.39'
  );
  bird_eye_ball2.setAttribute('class', 'eye-ball');
  bird_head.appendChild(bird_eye_ball2);

  bird_group.appendChild(bird_head);

  //         svg.appendChild(bird_group);

  //         document.body.appendChild(svg);
  return bird_group;
};

const tree = () => {
  const tree = createSVGElement('g');
  tree.setAttribute('id', 'tree');

  const bark = createSVGElement('path');
  bark.setAttribute('id', 'bark');
  bark.setAttribute(
    'd',
    'M397.004,230.629c0,0,4.18-27.65,1.73-35.82l-18.551-25.029l3.01-2.74l17.451,19.871     l1.91-37.601h4.439l1.83,24.531l15.26-16.35l3.27,4.359l-16.07,19.34c0,0-2.719,0-1.09,19.34     c1.631,19.34,3.002,29.699,3.002,29.699L397.004,230.629z'
  );
  tree.appendChild(bark);

  const leaves = createSVGElement('g');
  leaves.setAttribute('id', 'leaves');
  const leaves_paths = [
    'M402.645,144.19c0,0-14.92,4.339-23.52-14.051c0,0,19.398-7.979,24.369,11.9c0,0-9.68-3.57-13.07-6.73      C390.424,135.32,397.494,143.11,402.645,144.19z',
    'M379.744,166.029c0,0-15.939-1.51-17.199-22.39c0,0,21.619-0.27,18.83,20.659c0,0-7.922-7.1-9.971-11.41      C371.404,152.889,375.225,163.039,379.744,166.029z',
    'M407.305,143.67c0,0,1.709-18.09,25.4-19.51c0,0,0.309,24.53-23.441,21.36c0,0,8.061-8.98,12.951-11.31      C422.205,134.21,410.693,138.54,407.305,143.67z',
    'M428.385,161.229c0,0,12.58-13.83,32.959-0.379c0,0-14.889,20.379-32.479,3.109      c0,0,12.18-2.42,17.639-1.32C446.494,162.648,434.334,159.1,428.385,161.229z',
    'M425.885,157.84c0,0-6.221-14.46,11.189-25.38c0,0,10.43,18.509-8.93,25.97      c0,0,2.391-10.169,5.129-13.97C433.285,144.45,426.334,152.529,425.885,157.84z',
    'M404.184,134.69c0,0-13.709-14.16,1.811-34.69c0,0,20.439,17.021,1.09,34.38c0,0-1.73-12.97-0.209-18.64      C406.885,115.74,402.344,128.29,404.184,134.69z',
    'M377.574,173.17c0,0-10.131,11.6-27.141,0.85c0,0,11.93-17.041,26.711-3.1c0,0-9.99,2.189-14.51,1.379      C362.625,172.299,372.693,175.02,377.574,173.17z',
    'M381.764,178.709c0,0,2.189,15.25-17.049,21.141c0,0-5.141-20.15,15.068-22.27      c0,0-4.85,9.01-8.42,11.898C371.363,189.479,379.984,183.609,381.764,178.709z',
    'M384.924,166.629c0,0-5.359-11.6,8.551-20.849c0,0,8.859,14.8-6.701,21.279      c0,0,1.721-8.309,3.871-11.449C390.645,155.6,385.174,162.309,384.924,166.629z',
  ];

  leaves_paths.forEach((element) => {
    const leaf = createSVGElement('path');
    leaf.setAttribute('class', 'leaf');
    leaf.setAttribute('d', element);
    leaves.appendChild(leaf);
  });

  tree.appendChild(leaves);
  tree.style.transform =
    'scale(2) translate(-100px, -100px)';

  return tree;
};

const land = () => {
  const land = createSVGElement('g');
  const land1 = createSVGElement('path');
  land1.setAttribute(
    'd',
    'M 0 375 C 400 375 500 150 960 250 L 960 500 L 0 500 Z'
  );
  land1.setAttribute('fill', 'black');
  land1.setAttribute('id', 'land1');

  const land2 = createSVGElement('path');
  land2.setAttribute(
    'd',
    'M 0 300 Q 250 100 960 400 L 960 500 L 0 500 Z'
  );
  land2.setAttribute('fill', 'black');
  land2.setAttribute('id', 'land2');

  const land3 = createSVGElement('path');
  land3.setAttribute(
    'd',
    'M 0 270 Q -250 -100 960 400 L 960 500 L 0 500 Z'
  );
  land3.setAttribute('fill', 'black');
  land3.setAttribute('id', 'land1');
  land.appendChild(land3);
  land.appendChild(land2);
  land.appendChild(land1);
  return land;
};

const sky = () => {
  const sky = createSVGElement('g');
  sky.setAttribute('id', 'sky');
  const blue_sky = createSVGElement('rect');
  blue_sky.setAttribute('width', width);
  blue_sky.setAttribute('height', height);
  blue_sky.setAttribute('id', 'sky');
  blue_sky.setAttribute('fill', 'url(#skyGradient)');

  //   	const land2 = createSVGElement('path');
  //     land2.setAttribute('d', 'M 0 300 Q 250 100 960 400 L 960 500 L 0 500 Z');
  //   	land2.setAttribute('fill','black');
  //   	land2.setAttribute('id','land1');

  //   	land.appendChild(land2);
  sky.appendChild(blue_sky);
  const sun_g = createSVGElement('g');
  // sun_g.setAttribute('id', 'sun');
  sun_g.setAttribute('class', 'sun');

  const sun = createSVGElement('circle');
  sun.setAttribute('id','sun');
  sun.setAttribute('r', 50);
  sun.setAttribute('cx', width);
  sun.setAttribute('cy', height / 16);
  sun.setAttribute('class', 'sun');
  sun.setAttribute('fill', 'url(#sunGradient)');
  sun_g.appendChild(sun);

  sky.appendChild(sun_g);
  
  const cloudgg = createSVGElement('g');
  for (let i=0;i < getRandomInt(3,7);i++){
    const cloudg = createSVGElement('g');
    const cloud = createSVGElement('path');
    	cloud.setAttribute('d',"M48,32c0-8.8-7.2-16-16-16c-7.5,0-13.8,5.2-15.5,12.1C11.7,28.9,8,33,8,38c0,5.5,4.5,10,10,10h30    c4.4,0,8-3.6,8-8S52.4,32,48,32z");
      cloud.setAttribute('fill', '#F6FDC4');
      cloud.setAttribute('opacity', getRandomArbitrary(0.1,.9));
    	cloudg.setAttribute('class', 'cloud');
    const scale = getRandomArbitrary(1.1,3)
    	cloudg.setAttribute('style', `animation: slidein ${getRandomInt(29,50)}s infinite running linear;`);
    	cloudg.setAttribute('id', `cloud${i}`);
    	cloudg.setAttribute('transform', `scale(${scale}) translate(${getRandomArbitrary(0,width)} ${getRandomInt(-5,15)})`);
  	cloudg.appendChild(cloud);	

  
    	
    cloudgg.appendChild(cloudg);
  }
  sky.appendChild(cloudgg);
  
  
  return sky;
};
